# Products

## GET /products

> Returns products list

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ProductGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"client":{"$ref":"#/components/schemas/ClientGetList"},"sku":{"type":"string","nullable":true}},"additionalProperties":false},"BarcodeType":{"enum":["Code128","ITF14","EAN13","UPCA"],"type":"string"},"ClientGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"name":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/products":{"get":{"tags":["Products"],"summary":"Returns products list","parameters":[{"name":"Sku","in":"query","schema":{"type":"string"}},{"name":"ClientId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Page","in":"query","schema":{"type":"integer","format":"int32"}},{"name":"PageSize","in":"query","schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProductGetList"}}},"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProductGetList"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProductGetList"}}}}}}}}}}
```

## POST /products

> Create new product

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ProductCreate":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"clientId":{"type":"string","format":"uuid","nullable":true},"sku":{"type":"string","nullable":true},"isLotControlled":{"type":"boolean"},"lotPattern":{"type":"string","nullable":true},"isSerialControlled":{"type":"boolean"},"isBillOfMaterial":{"type":"boolean"},"serialPattern":{"type":"string","nullable":true},"isExpiryControlled":{"type":"boolean"},"isDecimalControlled":{"type":"boolean"},"isPacksizeControlled":{"type":"boolean"},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true},"height":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"dimsLengthUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"dimsWeightUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"unitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"category":{"type":"string","nullable":true},"freightClass":{"$ref":"#/components/schemas/FreightClass"},"image":{"type":"string","nullable":true},"nmfc":{"type":"string","nullable":true},"commodityDescription":{"type":"string","nullable":true},"htsCode":{"type":"string","nullable":true},"countryOfOrigin":{"type":"string","nullable":true},"packsizes":{"type":"array","items":{"$ref":"#/components/schemas/ProductPacksize"},"nullable":true},"productComponents":{"type":"array","items":{"$ref":"#/components/schemas/ProductComponent"},"nullable":true}},"additionalProperties":false},"BarcodeType":{"enum":["Code128","ITF14","EAN13","UPCA"],"type":"string"},"UnitOfMeasure":{"enum":["Gr","Kg","Oz","Lb","Ml","L","Pt","Gal","Mm","Cm","M","In","Ft"],"type":"string"},"FreightClass":{"enum":["Class50","Class55","Class60","Class65","Class70","Class77p5","Class85","Class92p5","Class100","Class110","Class125","Class150","Class175","Class200","Class250","Class300","Class400","Class500"],"type":"string"},"ProductPacksize":{"type":"object","properties":{"name":{"type":"string","nullable":true},"eachCount":{"type":"integer","format":"int32"},"barcodeValue":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"height":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true}},"additionalProperties":false},"ProductComponent":{"type":"object","properties":{"componentProductId":{"type":"string","format":"uuid"},"quantity":{"type":"number","format":"double"}},"additionalProperties":false},"ProductGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"client":{"$ref":"#/components/schemas/ClientGetList"},"sku":{"type":"string","nullable":true}},"additionalProperties":false},"ClientGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"name":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/products":{"post":{"tags":["Products"],"summary":"Create new product","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductCreate"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProductCreate"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/ProductCreate"}}}},"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProductGetList"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProductGetList"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProductGetList"}}}},"406":{"description":"Not Acceptable","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```

## PUT /products

> Update an existing product

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ProductUpdate":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"sku":{"type":"string","nullable":true},"isLotControlled":{"type":"boolean"},"lotPattern":{"type":"string","nullable":true},"isSerialControlled":{"type":"boolean"},"isBillOfMaterial":{"type":"boolean"},"serialPattern":{"type":"string","nullable":true},"isExpiryControlled":{"type":"boolean"},"isDecimalControlled":{"type":"boolean"},"isPacksizeControlled":{"type":"boolean"},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true},"height":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"dimsLengthUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"dimsWeightUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"unitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"category":{"type":"string","nullable":true},"freightClass":{"$ref":"#/components/schemas/FreightClass"},"image":{"type":"string","nullable":true},"nmfc":{"type":"string","nullable":true},"commodityDescription":{"type":"string","nullable":true},"htsCode":{"type":"string","nullable":true},"countryOfOrigin":{"type":"string","nullable":true},"packsizes":{"type":"array","items":{"$ref":"#/components/schemas/ProductPacksize"},"nullable":true},"productComponents":{"type":"array","items":{"$ref":"#/components/schemas/ProductComponent"},"nullable":true}},"additionalProperties":false},"BarcodeType":{"enum":["Code128","ITF14","EAN13","UPCA"],"type":"string"},"UnitOfMeasure":{"enum":["Gr","Kg","Oz","Lb","Ml","L","Pt","Gal","Mm","Cm","M","In","Ft"],"type":"string"},"FreightClass":{"enum":["Class50","Class55","Class60","Class65","Class70","Class77p5","Class85","Class92p5","Class100","Class110","Class125","Class150","Class175","Class200","Class250","Class300","Class400","Class500"],"type":"string"},"ProductPacksize":{"type":"object","properties":{"name":{"type":"string","nullable":true},"eachCount":{"type":"integer","format":"int32"},"barcodeValue":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"height":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true}},"additionalProperties":false},"ProductComponent":{"type":"object","properties":{"componentProductId":{"type":"string","format":"uuid"},"quantity":{"type":"number","format":"double"}},"additionalProperties":false},"ProductGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"client":{"$ref":"#/components/schemas/ClientGetList"},"sku":{"type":"string","nullable":true}},"additionalProperties":false},"ClientGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"name":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/products":{"put":{"tags":["Products"],"summary":"Update an existing product","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductUpdate"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProductUpdate"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/ProductUpdate"}}}},"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProductGetList"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProductGetList"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProductGetList"}}}},"406":{"description":"Not Acceptable","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```

## GET /products/{id}

> Returns a single product by id

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}},"schemas":{"ProductGetDetail":{"type":"object","properties":{"description":{"type":"string","nullable":true},"upc":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"barcodeValue":{"type":"string","nullable":true},"referenceNumber":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"client":{"$ref":"#/components/schemas/ClientGetList"},"sku":{"type":"string","nullable":true},"isLotControlled":{"type":"boolean"},"lotPattern":{"type":"string","nullable":true},"isSerialControlled":{"type":"boolean"},"isBillOfMaterial":{"type":"boolean"},"serialPattern":{"type":"string","nullable":true},"isExpiryControlled":{"type":"boolean"},"isDecimalControlled":{"type":"boolean"},"isPacksizeControlled":{"type":"boolean"},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true},"height":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"dimsLengthUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"dimsWeightUnitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"unitOfMeasure":{"$ref":"#/components/schemas/UnitOfMeasure"},"category":{"type":"string","nullable":true},"freightClass":{"$ref":"#/components/schemas/FreightClass"},"image":{"type":"string","nullable":true},"nmfc":{"type":"string","nullable":true},"commodityDescription":{"type":"string","nullable":true},"htsCode":{"type":"string","nullable":true},"countryOfOrigin":{"type":"string","nullable":true},"packsizes":{"type":"array","items":{"$ref":"#/components/schemas/ProductPacksize"},"nullable":true},"productComponents":{"type":"array","items":{"$ref":"#/components/schemas/ProductComponent"},"nullable":true}},"additionalProperties":false},"BarcodeType":{"enum":["Code128","ITF14","EAN13","UPCA"],"type":"string"},"ClientGetList":{"type":"object","properties":{"description":{"type":"string","nullable":true},"ssccCompanyId":{"type":"string","nullable":true},"companyName":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"contactPerson":{"type":"string","nullable":true},"taxId":{"type":"string","nullable":true},"address1":{"type":"string","nullable":true},"address2":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"stateProvince":{"type":"string","nullable":true},"zipPostalCode":{"type":"string","nullable":true},"country":{"type":"string","nullable":true},"id":{"type":"string","format":"uuid"},"name":{"type":"string","nullable":true}},"additionalProperties":false},"UnitOfMeasure":{"enum":["Gr","Kg","Oz","Lb","Ml","L","Pt","Gal","Mm","Cm","M","In","Ft"],"type":"string"},"FreightClass":{"enum":["Class50","Class55","Class60","Class65","Class70","Class77p5","Class85","Class92p5","Class100","Class110","Class125","Class150","Class175","Class200","Class250","Class300","Class400","Class500"],"type":"string"},"ProductPacksize":{"type":"object","properties":{"name":{"type":"string","nullable":true},"eachCount":{"type":"integer","format":"int32"},"barcodeValue":{"type":"string","nullable":true},"barcodeType":{"$ref":"#/components/schemas/BarcodeType"},"height":{"type":"number","format":"double","nullable":true},"width":{"type":"number","format":"double","nullable":true},"length":{"type":"number","format":"double","nullable":true},"weight":{"type":"number","format":"double","nullable":true},"palletTie":{"type":"integer","format":"int32","nullable":true},"palletHeight":{"type":"integer","format":"int32","nullable":true}},"additionalProperties":false},"ProductComponent":{"type":"object","properties":{"componentProductId":{"type":"string","format":"uuid"},"quantity":{"type":"number","format":"double"}},"additionalProperties":false}}},"paths":{"/products/{id}":{"get":{"tags":["Products"],"summary":"Returns a single product by id","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProductGetDetail"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProductGetDetail"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProductGetDetail"}}}},"404":{"description":"Not Found","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```

## DELETE /products/{id}

> Delete product by Id

```json
{"openapi":"3.0.1","info":{"title":"P4W Api Gateway","version":"v1"},"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"Api key taken from 'Gateway API key' setting.","name":"ApiKey","in":"header"}}},"paths":{"/products/{id}":{"delete":{"tags":["Products"],"summary":"Delete product by Id","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK"},"406":{"description":"Not Acceptable","content":{"text/plain":{"schema":{"type":"string"}},"application/json":{"schema":{"type":"string"}},"text/json":{"schema":{"type":"string"}}}}}}}}}
```
